SystemOrganization addCategory: #'Pier-Commands-RemoveChildren'!

PRCommand subclass: #PRRemoveChilden
	instanceVariableNames: 'childrenToRemove'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Commands-RemoveChildren'!

!PRRemoveChilden class methodsFor: 'accessing-description' stamp: 'kph 10/26/2007 17:50'!
descriptionChildrenToRemove
	^ (MAMultipleOptionDescription selector: #childrenToRemove label: 'Children to remove')
		options: [ self visibleChildren ] asDynamicObject;
		reference: PRStructureDescription new;
		yourself
		
	 ! !

!PRRemoveChilden class methodsFor: 'testing' stamp: 'dc 1/2/2006 21:58'!
isAbstract
	^ false! !

!PRRemoveChilden class methodsFor: 'testing' stamp: 'kph 11/4/2007 00:23'!
isValidIn: aContext
 
	^ (super isValidIn: aContext)
		and: [ aContext structure hasChildren ]! !

!PRRemoveChilden class methodsFor: 'accessing' stamp: 'kph 11/4/2007 00:23'!
structureClass
	^ PRStructure! !

!PRRemoveChilden class methodsFor: 'accessing-description' stamp: 'kph 11/4/2007 00:24'!
visibleChildren

	^ PRCurrentContext value in: [ :context |
		 
		context enumerator select:[ :s | s isValidCommand: PRRemoveCommand in: context  ]
	
	]! !

!PRRemoveChilden methodsFor: 'accessing' stamp: 'dc 1/2/2006 21:52'!
childrenToRemove
	^ childrenToRemove! !

!PRRemoveChilden methodsFor: 'accessing' stamp: 'dc 1/2/2006 21:52'!
childrenToRemove: aCollection 
	childrenToRemove := aCollection! !

!PRRemoveChilden methodsFor: 'events' stamp: 'dc 1/3/2006 06:11'!
doExecute
	super doExecute.
	self childrenToRemove do: [:child |
		(PRRemoveCommand context: (self context structure: child)) execute]
			
		
		! !

!PRRemoveChilden methodsFor: 'events' stamp: 'dc 1/2/2006 21:52'!
doInitialize
	super doInitialize.
	childrenToRemove := OrderedCollection new! !

!PRRemoveChilden methodsFor: 'events' stamp: 'kph 10/26/2007 17:53'!
saveButton

^ #save -> 'Remove'! !
